proc PGCD_GT(ideal I, ideal Equ, ideal DisEqu, list C, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  if (size(I_Variables)==1)
  {
    list Prim;
    list G = cgs( I, Equ, DisEqu, I_Variables,I_Parameters, RingAll, RingVar);
    for (int i=1;i<=size(G);i++)
    {
      Prim = Prim + list(list(G[i][1],G[i][2],G[i][3][1]));
    }
    return(Prim);
  }

  list Primitive_I = Primitive_ideal(I, Equ, DisEqu, C, I_Variables, I_Parameters, RingAll, RingVar);
  list nonvanishlc_I = Dec_nonvanishlc(Primitive_I, I_Variables, I_Parameters, RingAll, RingVar);
  list pre_I = Pre_Decomp(nonvanishlc_I, I_Variables, I_Parameters, RingAll, RingVar);
  
  int i,j;
  list LI,LT;
  list pre_I_1 = pre_I;
  int k0 = 0;
  for(i=1;i<=size(pre_I_1);i++)
  {
    int k1 = 0;
    for(j=1;j<=size(pre_I_1[i][4]);j++)
    {
      if(pre_I_1[i][4][j]==0)
      {
        pre_I[i][4] = delete(pre_I[i][4],j-k1);
        k1 = k1 + 1;
      }
    }
    if(size(pre_I[i-k0][4])==0)
    {
      pre_I = delete(pre_I,i-k0);
      LT = LT + list(list(pre_I_1[i][1],pre_I_1[i][2],poly(0)));
      k0 = k0 + 1;
    }
  }
  list Sub_I = Sub_main( pre_I, C, I_Variables, I_Parameters, RingAll, RingVar);
  
  while (size(Sub_I) > 0)
  {
    LI = Sub_I[1];
    Sub_I = delete(Sub_I,1);

    int k = Integer_k(LI[4]); 
    list F = LI[4];
    ideal J = F[1..size(F)];
    J = J + (LI[6])^k;
    list G = cgs( J, LI[1], LI[2], I_Variables,I_Parameters, RingAll, RingVar);

    int n = size(G);
    poly g;
    int t;
    ideal GF;
    list TT;
    list FF;
    for (j=1;j<=n;j++)
    {
      g = minimal_poly(G[j][3],G[j][1],G[j][2]);
      if (poly_in_U(g)==1)
      {
        LT = LT + list(list(G[j][1],G[j][2],LI[3]));
      }
      else
      {
        t,GF = Divide_poly( g, LI[4], G[j][1], G[j][2]);
        if (t == 1)
        {
          TT = PGCD_GT(GF, G[j][1], G[j][2], C, I_Variables, I_Parameters, RingAll, RingVar);
          for (i=1;i<=size(TT);i++)
          {
            LT = LT + list(list(TT[i][1],TT[i][2],LI[3]*g*TT[i][3]));
          }
        }
        else
        {
          list T = list(G[j][1], G[j][2], LI[3], LI[4],LI[5]);
          FF = Sub_routine( T, C, I_Variables, I_Parameters, RingAll, RingVar);
          Sub_I = Sub_I + FF;
        }
      }
    }
  }
  LT = Final_result(LT);
  return(LT);
}


static proc Primitive_ideal(ideal I, ideal Equ, ideal DisEqu, list C, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  list G,Prim;
  list I_Vars = delete(I_Variables,1);
  Prim = Primitive_poly(I[1],Equ,DisEqu, C,I_Variables,I_Parameters,RingAll,RingVar);
  int s1 = size(I);
  if (s1>1)
  {
    int s2,s3,s4,s5,s6,s7,s8;
    list temp_prim,coe_f;
    ideal J;
    for (s2=2;s2<=s1;s2++)
    {
      s3 = size(Prim);
      list Prim1;
      for (s4=1;s4<=s3;s4++)
      {
        temp_prim = Primitive_poly(I[s2],Prim[s4][1],Prim[s4][2], C, I_Variables,I_Parameters,RingAll,RingVar);
        s5 = size(temp_prim);
        list Prim2;
        int k;
        list T;
        for (s6=1;s6<=s5;s6++)
        {
          coe_f = temp_prim[s6][4] + Prim[s4][4];

          k,T = check_poly(temp_prim[s6][3], Prim[s4][3],temp_prim[s6][1],temp_prim[s6][2]);
          if(k==1)
          {
            Prim2 = Prim2 + list(list(temp_prim[s6][1],temp_prim[s6][2],T[1],coe_f));
          }
          else
          {
            J = T[1..size(T)];
            G = PGCD_GT( J, temp_prim[s6][1], temp_prim[s6][2], C, I_Vars, I_Parameters, RingAll, RingVar);
            s7 = size(G);
            for(s8=1;s8<=s7;s8++)
            {
              Prim2 = Prim2 + list(list(G[s8][1],G[s8][2],G[s8][3],coe_f));
            }
          }
        }
        Prim1 = Prim1 + Prim2;
      }
      Prim = Prim1;
    }   
  }
  return(Prim);
}



static proc Primitive_poly(poly f, ideal Equ, ideal DisEqu, list C, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  f = Poly_Simplify(f, Equ, DisEqu);
  if(f==0)
  {
    list T = list(list(Equ,DisEqu,0,list(0)));
  }
  else
  {
    list T,G;
    int i;
    list I_Vars = I_Variables;    
    matrix M = coef(f,I_Vars[1]);
    ideal J = M[2,1..ncols(M)];
    I_Vars = delete(I_Vars,1);
    G = PGCD_GT(J, Equ, DisEqu, C, I_Vars, I_Parameters, RingAll, RingVar);     
    poly h1,h2;
    for (i=1;i<=size(G);i++)
    {
      h1,h2 = Parametric_Division(f, G[i][3], G[i][1], G[i][2]);
      T = T + list(list(G[i][1],G[i][2],G[i][3],list(h1)));
    }
  }
  return(T);
}



static proc Dec_nonvanishlc(list L, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  int k = size(L);
  int i,j,s,p,q,r,n; 
  list LT;
  for (i=1;i<=k;i++)
  {
    s = size(L[i][4]);
    list G;
    G = cgs( L[i][4][1], L[i][1], L[i][2], I_Variables,I_Parameters, RingAll, RingVar); 
    if (s>1)
    {
      for (j=2;j<=s;j++)
      {
        p = size(G);
        list G1,G2;
        for (q=1;q<=p;q++)
        { 
          G2 = cgs( L[i][4][j], G[q][1], G[q][2], I_Variables,I_Parameters, RingAll, RingVar);
          for (n=1;n<=size(G2);n++)
          {
            G2[n][3] = G2[n][3] + G[q][3];
          } 
          G1 = G1 + G2; 
        }
        G = G1;
      }
      for (r=1;r<=size(G);r++)
      {
        LT = LT + list(list(G[r][1],G[r][2],L[i][3],G[r][3]));
      }
    }
    else
    {
      for (r=1;r<=size(G);r++)
      {
        LT = LT + list(list(G[r][1],G[r][2],L[i][3],G[r][3]));
      }  
    }  
  }
  return(LT);
}


static proc Pre_Decomp(list L, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  int k = size(L);
  list LT;
  int i,j,m;
  ideal J;
  list G;
  for (i=1;i<=k;i++)
  {
    J = Ideal_LeadCoe(L[i][4],I_Variables, RingAll, RingVar);
    G = cgs(J, L[i][1], L[i][2], I_Variables,I_Parameters, RingAll, RingVar);   
    m = size(G);
    for (j=1;j<=m;j++)
    {
      LT = LT + list(list(G[j][1],G[j][2],L[i][3],L[i][4],G[j][3]));
    }
  }
  return(LT);
}


static proc Sub_main(list L,list C, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  int m = size(L);
  list T;
  list LT;
  int i,j;
  int n;
  for (i=1;i<=m;i++)
  {
    T = Sub_routine(L[i], C, I_Variables, I_Parameters, RingAll, RingVar);
    LT = LT + T;
    n = size(T);
    for (j=1;j<=n;j++)
    {
      C = C + T[j][7];
    }   
  }
  return(LT);
}


static proc Sub_routine(list T, list C, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  int i;
  int c = random(1,2);
  if (size(C)==0)
  {
    C = C + list(c);
  }
  else
  {
    for (i=1;i<=size(C);i++)
    {
      c = c + C[i];
    }
    C = C + list(c);
  }
  int d = Max_degree(T[4], I_Variables) + 1;
  int n = size(I_Variables);
  ideal J;
  int d1;
  for (i=2;i<=n;i++)  
  {
    d1 = (d*(i-1)*c) mod (2*n);
    d1 = d1 + 1;
    J = J + ideal(I_Variables[i]-d1);
  }
  ideal I;
  for (i=1;i<=size(T[5]);i++)
  {
    I = I + ideal(T[5][i]);
  }
  I = I + J;

  list G = cgs( I, T[1], T[2], I_Variables,I_Parameters, RingAll, RingVar);
  int m = size(G);
  list Lt;
  list T1;
  int k;
  for (i=1;i<=m;i++)
  {
    k = Inter_section(G[i][3], I_Variables);
    if (k==1)
    {
      Lt = Lt + list(list(G[i][1],G[i][2],T[3],T[4],T[5],J,C));
    }
    else
    {
      T1 = list(G[i][1], G[i][2] , T[3], T[4], T[5]);
      Lt = Lt + Sub_routine(T1, C, I_Variables, I_Parameters, RingAll, RingVar);
    }
  }
  return(Lt);
}