proc PGCD_SS(ideal I, ideal Equ, ideal DisEqu, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  if (size(I_Variables)==1)
  {
    list Prim;
    list G = cgs( I, Equ, DisEqu, I_Variables,I_Parameters, RingAll, RingVar);
    for (int i=1;i<=size(G);i++)
    {
      Prim = Prim + list(list(G[i][1],G[i][2],G[i][3][1]));
    }
    return(Prim);
  }

  list Primitive_I = Primitive_ideal_SS(I, Equ, DisEqu, I_Variables, I_Parameters, RingAll, RingVar);
  
  int i,j;
  list LT;
  list pre_I_1 = Primitive_I;
  int k0 = 0;
  for(i=1;i<=size(pre_I_1);i++)
  {
    int k1 = 0;
    for(j=1;j<=size(pre_I_1[i][4]);j++)
    {
      if(pre_I_1[i][4][j]==0)
      {
        Primitive_I[i][4] = delete(Primitive_I[i][4],j-k1);
        k1 = k1 + 1;
      }
    }
    if(size(Primitive_I[i-k0][4])==0)
    {
      Primitive_I = delete(Primitive_I,i-k0);
      LT = LT + list(list(pre_I_1[i][1],pre_I_1[i][2],poly(0)));
      k0 = k0 + 1;
    }
  }
 
  ideal J;
  list LI,G,G1;
  for(i=1;i<=size(Primitive_I);i++)
  {
    LI = Primitive_I[i][4];
    J = LI[1..size(LI)];
    G = cgs(J,Primitive_I[i][1],Primitive_I[i][2],I_Variables, I_Parameters, RingAll, RingVar);
    G1 = G1 + Minimal_poly_SS(Primitive_I[i][3],G,I_Variables);
  }

  int k2 = 0;
  list G2 = G1;
  for(i=1;i<=size(G2);i++)
  {
    if(G2[i][4]==0)
    {
      LT = LT + list(list(G2[i][1],G2[i][2],poly(0)));
      G1 = delete(G1,i-k2);
      k2 = k2 + 1;
    }
  }

  matrix M;
  list G3;
  list I_Vars = delete(I_Variables,1);
  for(i=1;i<=size(G1);i++)
  {
    M = coef(G1[i][4],I_Variables[1]);
    J = M[2,1..ncols(M)];
    G = PGCD_SS(J,G1[i][1], G1[i][2], I_Vars, I_Parameters, RingAll, RingVar);
    for(j=1;j<=size(G);j++)
    {
      G3 = G3 + list(list(G[j][1],G[j][2],G1[i][3],G[j][3],G1[i][4]));
    }
  }

  poly h1,h2;
  for(i=1;i<=size(G3);i++)
  {
    h1,h2 = Parametric_Division(G3[i][5], G3[i][4], G3[i][1], G3[i][2]);
    LT = LT + list(list(G3[i][1],G3[i][2],G3[i][3]*h1));
  }
  
  return(LT);
}



proc Minimal_poly_SS(poly h, list G, list I_Variables)
{
  int i,j,k;
  list T;
  matrix M;
  poly f;
  for(i=1;i<=size(G);i++)
  {
    if(G[i][3][1]!=0)
    {
      M = coef(G[i][3][1],I_Variables[1]);
      k = deg(M[1][1]);
      f = G[i][3][1];
      for(j=2;j<=size(G[i][3]);j++)
      {
        M = coef(G[i][3][j],I_Variables[1]);
        if(deg(M[1][1])<k)
        {
          k = deg(M[1][1]);
          f = G[i][3][j];
        }
      }
      T = T + list(list(G[i][1],G[i][2],h,f));
    }
    else
    {
      T = T + list(list(G[i][1],G[i][2],h,poly(0)));
    }
  }
  return(T);
}        
      


proc Primitive_ideal_SS(ideal I, ideal Equ, ideal DisEqu, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  list G,Prim;
  list I_Vars = delete(I_Variables,1);
  Prim = Primitive_poly_SS(I[1],Equ,DisEqu,I_Variables,I_Parameters,RingAll,RingVar);
  int s1 = size(I);
  if (s1>1)
  {
    int s2,s3,s4,s5,s6,s7,s8;
    list temp_prim,coe_f;
    ideal J;
    for (s2=2;s2<=s1;s2++)
    {
      s3 = size(Prim);
      list Prim1;
      for (s4=1;s4<=s3;s4++)
      {
        temp_prim = Primitive_poly_SS(I[s2],Prim[s4][1],Prim[s4][2],I_Variables,I_Parameters,RingAll,RingVar);
        s5 = size(temp_prim);
        list Prim2;
        int k;
        list T;
        for (s6=1;s6<=s5;s6++)
        {
          coe_f = temp_prim[s6][4] + Prim[s4][4];

          k,T = check_poly(temp_prim[s6][3], Prim[s4][3],temp_prim[s6][1],temp_prim[s6][2]);
          if(k==1)
          {
            Prim2 = Prim2 + list(list(temp_prim[s6][1],temp_prim[s6][2],T[1],coe_f));
          }
          else
          {
            J = T[1..size(T)];
            G = PGCD_SS( J, temp_prim[s6][1], temp_prim[s6][2], I_Vars, I_Parameters, RingAll, RingVar);
            s7 = size(G);
            for(s8=1;s8<=s7;s8++)
            {
              Prim2 = Prim2 + list(list(G[s8][1],G[s8][2],G[s8][3],coe_f));
            }
          }
        }
        Prim1 = Prim1 + Prim2;
      }
      Prim = Prim1;
    }   
  }
  return(Prim);
}



proc Primitive_poly_SS(poly f, ideal Equ, ideal DisEqu, list I_Variables, list I_Parameters, RingAll, RingVar)
{
  f = Poly_Simplify(f, Equ, DisEqu);
  if(f==0)
  {
    list T = list(list(Equ,DisEqu,0,list(0)));
  }
  else
  {
    list T,G;
    int i;
    list I_Vars = I_Variables;    
    matrix M = coef(f,I_Vars[1]);
    ideal J = M[2,1..ncols(M)];
    I_Vars = delete(I_Vars,1);
    G = PGCD_SS(J, Equ, DisEqu, I_Vars, I_Parameters, RingAll, RingVar);     
    poly h1,h2;
    for (i=1;i<=size(G);i++)
    {
      h1,h2 = Parametric_Division(f, G[i][3], G[i][1], G[i][2]);
      T = T + list(list(G[i][1],G[i][2],G[i][3],list(h1)));
    }
  }
  return(T);
}