// the subroutines only in Algorithm_1 and Algorithm_2

proc Simplify_result(list T)
{
  poly h;
  for(int i=1;i<=size(T);i++)
  {
    if(T[i][3][1]!=0)
    {
      h = content_poly(T[i][3][1],T[i][1],T[i][2]);
      T[i][3][1] = h;
    }
  }
  return(T);
}



// the subroutines only in Nagasaka's algorithms

proc check_poly(poly f, poly g, ideal Equ, ideal DisEqu)
{
  poly f1 = Poly_Simplify(f, Equ, DisEqu);
  poly g1 = Poly_Simplify(g, Equ, DisEqu);
  int k;
  list T;
  if(f1 == g1)
  {
    k = 1;
    T = list(f1);
  }
  else
  {
    if(f1==0)
    {
      k = 1;
      T = list(g1);
    }
    else
    {
      if(g1==0)
      {
        k = 1;
        T = list(f1);
      }
      else
      {
        if(poly_in_U(f1)==1 or poly_in_U(g1)==1)
        {
          k = 1;
          T = list(1);
        }
        else
        {
          setring(RingVar);
          poly f2 = imap(RingAll,f1);
          poly g2 = imap(RingAll,g1);
          list T1;
          while (size(f2) > 0)
          {  
            T1 = T1 + list(leadcoef(f2));
            f2 = f2 - lead(f2);
          }
          while (size(g2) > 0)
          {  
            T1 = T1 + list(leadcoef(g2));
            g2 = g2 - lead(g2);
          }
          setring(RingAll);
          list T2 = imap(RingVar,T1);
          int n = size(T2);
          int k1 = 1;
          for(int i=1;i<=n;i++)
          {
            if(deg(T2[i])>0)
            {
              k1 = 0;
              break;
            }
          }
          if(k1==1)  
          {
            k = 1;
            T =list(gcd(f1,g1));
          }
          else
          {
            k = 0;
            T = list(f1,g1);
          }
        }
      }
    }
  }
  return(k,T);
}


proc Ideal_equality(ideal I, ideal J)
{
  option(redSB);
  ideal GI = std(I);
  ideal GJ = std(J);
  int n = size(GI);
  int m = size(GJ);
  int k = 0;
  int s = 0;
  int i,j;  
  for (i=1;i<=n;i++)
  {
    if (reduce(GI[i],GJ)==0)
    {
      k = k + 1;
    }
  }
  for (j=1;j<=m;j++)
  {
    if (reduce(GJ[j],GI)==0)
    {
      s = s + 1;
    }
  }
  if (k==n and s==m)
  {
    return(1);
  }
  else
  {
    return(0);
  }
}


proc Ideal_LeadCoe(list T, list I_Variables, RingAll, RingVar)
{
  int i;
  list T0 = T;
  int k1 = 0;
  for(i=1;i<=size(T0);i++)
  {
    if(T0[i]==0)
    {
      T = delete(T,i-k1);
      k1 = k1 + 1;
    }
  }
  if(size(T)==0)
  {
    return(ideal(0));
  }
  int k = 0;
  for(i=1;i<=size(T);i++)
  {
    if(deg(T[i])==0)
    {
      k = k + 1;
    }
  }
  if(k == size(T))
  {
    return(ideal(1));
  }
  setring(RingVar);
  list T1 = imap(RingAll,T);
  list T1_Variables = imap(RingAll,I_Variables);
  int m = size(T1);
  poly f;
  matrix M;
  list T2;
  for (int i=1;i<=m;i++)
  {
    f = lead(T1[i]);
    M = coef(f,T1_Variables[1]);
    T2 = T2 + list(M[2,1]);
  }
  setring(RingAll);
  list T3 = imap(RingVar,T2);
  ideal J = T3[1..size(T3)];
  return(J);
}


proc Max_degree(list T, list I_Variables)
{
  int i,j;
  int k =0;
  matrix M;
  for(i=1;i<=size(T);i++)
  {
    for(j=1;j<=size(I_Variables);j++)
    {
      M = coef(T[i],I_Variables[j]);
      if(deg(M[1,1]) > k)
      {
        k = deg(M[1,1]);
      }
    }
  }
  return(k);
}


proc Inter_section(list T)
{
  int i;
  list T1 = T;
  int k = 0;
  for(i=1;i<=size(T1);i++)
  {
    if(T1[i]==0)
    {
      T = delete(T,i-k);
      k = k + 1;
    }
  }
  for (i=1;i<=size(T);i++)
  {
    if(poly_in_U(T[i])==1)
    {
      return(1);
    }
  }
  return(0);
}


proc Integer_k(list T)
{
  int n = 0;
  for(int i=1;i<=size(T);i++)
  {
    if(deg(T[i])==0)
    {
      n = n + 1;
    }
  }
  if(n == size(T))
  {
    return(1);
  }
  setring(RingVar);
  list T1 = imap(RingAll,T);
  int k = 0;
  
  for(i=1;i<=size(T1);i++)
  {
    if(2*deg(T1[i]) > k)
    {
      k = 2*deg(T1[i]);
    }
  }
  k = k + 1;
  setring(RingAll);
  return(k);
}


proc minimal_poly(list W,ideal Equ, ideal DisEqu)
{
  list W1;
  poly f;
  for(int i=1;i<=size(W);i++)
  {
    f = Poly_Simplify(W[i], Equ, DisEqu);
    if(f!=0)
    {
      W1 = W1 + list(f);
    }
  }
  setring(RingVar);
  list T = imap(RingAll,W1);
  poly f = T[1];

  for (int i=2;i<=size(T);i++)
  {
    if (deg(T[i]) < deg(f))
    {
      f = T[i];
    }
  }
  setring(RingAll);
  poly f1 = imap(RingVar,f);
  return(f1);
}


proc Final_result(list T)
{
  poly h;
  for(int i=1;i<=size(T);i++)
  {
    if(T[i][3]!=0)
    {
      h = content_poly(T[i][3],T[i][1],T[i][2]);
      T[i][3] = h;
    }
  }
  return(T);
}


proc Divide_poly(poly g, list T, ideal Equ, ideal DisEqu)
{
  int k = 0;
  list T1;
  poly q,r;
  for (int i=1;i<=size(T);i++)
  { 
    q,r = Parametric_Division(T[i],g, Equ, DisEqu);
    if(r != 0)
    {
      return(0,ideal());
    }
    T1 = T1 + list(q);
  }
  ideal I = T1[1..size(T1)];
  return(1,I);
}


proc transform_list(list G)
{
  list T;
  for(int i=1;i<=size(G);i++)
  {
    T = T + list(list(G[i][1],G[i][2],list(G[i][3])));
  }
  return(T);
}



// the subroutines in all algorithms

proc content_poly(poly f, ideal Equ, ideal DisEqu)
{
  poly h = Poly_Simplify( f, Equ, DisEqu);
  int k = poly_in_U(h);
  if (k==0)
  {
    setring(RingVar);
    poly h1 = imap(RingAll,h);
    list T1;
    while (size(h1) > 0)
    {  
      T1 = T1 + list(list(leadmonom(h1),leadcoef(h1)));
      h1 = h1 - lead(h1);
    }   
    setring(RingAll);
    list T2 = imap(RingVar,T1);
    poly h2 = T2[1][2];
    for (int i=1;i<=size(T2);i++)
    {
      h2 = gcd(h2,T2[i][2]);
    }
    h = h/h2;
  }
  return(h);
}


proc poly_in_U(poly h)
{
  if(deg(h)==0 or deg(h)==-1)
  {
    return(1);
  }
  setring(RingVar);
  poly f = imap(RingAll,h);
  int k=0;
  if (deg(f) == 0)
  {
    k=1;
  }
  setring(RingAll);
  return(k);
}


proc Poly_Simplify(poly h, ideal Equ, ideal DisEqu)
{
  if (h==0 or size(Equ)==0)
  {
    return(h);
  }
  else
  {
    ideal E = radical(Equ);
    if (size(DisEqu) > 0)
    {
      ideal DE = radical(DisEqu);
      ideal Q = quotient(E,DE);
    }
    else
    {
      ideal Q = E;
    }
    option(redSB);
    ideal G = std(Q);
    if(G[1]==1)
    {
      return(h);
    }
    else
    {
      setring(RingVar);
      poly h1 = imap(RingAll,h);
      list T1;
      while (size(h1) > 0)
      {  
        T1 = T1 + list(list(leadmonom(h1),leadcoef(h1)));
        h1 = h1 - lead(h1);
      }   
      setring(RingAll);
      list T2 = imap(RingVar,T1); 
      poly r,h2;
      for (int i=1;i<=size(T2);i++)
      {
        r = reduce(T2[i][2],G);
        h2 = h2 + T2[i][1]*r;
      }
      return(h2);
    }
  }
}


proc Parametric_Division(poly f, poly g, ideal Equ, ideal DisEqu)
{
  poly f1 = Poly_Simplify(f, Equ, DisEqu);
  poly g1 = Poly_Simplify(g, Equ, DisEqu);
  setring(RingVar);
  poly f2 = imap(RingAll,f1);
  ideal J = imap(RingAll,g1);
  list S = pdivi(f2,J);
  poly rr = S[1];
  poly qq = S[2][1];
  setring(RingAll);
  poly r = imap(RingVar,rr);
  poly q = imap(RingVar,qq);
  r = Poly_Simplify(r, Equ, DisEqu);
  q = Poly_Simplify(q, Equ, DisEqu);
  return(q,r);
}


proc StringGCD(list cgs)
{
  int i, j, k;
  string Str = newline + "The gcd system of parametric polynomials on V(E)-V(N) are:" + newline + newline;
  for (i = 1; i <= size(cgs); i++)
  {
    Str = Str + "Branch " + string(i) + ":" + newline + "parametric constraint V(E): " + newline;
    k = size(cgs[i][1]);
    if ( k == 0 )
    { 
      Str = Str + "V(0)";
    }
    else
    {
      Str = Str + "V(";
      if(k==1)
      {
        Str = Str + string(cgs[i][1][1]) + ")";
      }
      else
      {
        for (j = 1; j <= k-1; j++)
        {
          Str = Str + string(cgs[i][1][j]) + ", ";
        }
        Str = Str + string(cgs[i][1][k]) + ")";
      }
    }
    Str = Str + newline + "parametric constraint V(N): " + newline;
    k = size(cgs[i][2]);
    if ( k == 0 )
    { 
      Str = Str + "V(1)" ;
    }
    else
    {
      Str = Str + "V(";
      if(k==1)
      {
        Str = Str + string(cgs[i][2][1]) + ")";
      }
      else
      {
        for (j = 1; j <= k-1; j++)
        {
          Str = Str + string(cgs[i][2][j]) + ", ";
        }
        Str = Str + string(cgs[i][2][k]) + ")";
      }
    }
    Str = Str + newline + "The gcd of parametric polynomials on V(E)-V(N) is: " + newline;
    Str = Str + string(cgs[i][3][1]) + "." + newline + newline;
  }
  return(Str);
}



proc cgs(ideal Polys, ideal Equ, ideal DisEqu, list Vars, list Paras, RingAll, RingVar)
{
  list Parameters = Paras;
  list Variables = Vars;
  export(Parameters, Variables);

  export(RingVar, RingAll);
  setring(RingAll);

  list G = cgs_main(Polys, Equ, DisEqu);
  keepring(RingAll);
  return(G);
}


static proc cgs_main(ideal Polys, ideal Equ, ideal DisEqu)
{
  ideal GB, Gs, Gr, newEqu, newDisEqu, LeadCoeffFactors;
  list MDBasis, CGSystems;
  poly H;
  int i,j;

  newEqu = Simplify_Equ(Equ);
  newDisEqu = Simplify_DisEqu(newEqu,DisEqu);

  //check consistence of (Equ, DisEqu)
  if (!Check_Consistence(newEqu, newDisEqu))
  {
    return(list());
  }  

  //compute the full elinimating Grobner basis
  GB = groebner(Polys + newEqu);
  if (GB[1] == 1)
  {
    return(list(list(newEqu, newDisEqu, list(1))));
  }

  //get minimal Dickson basis
  MDBasis, Gs, Gr, H, LeadCoeffFactors = Separate_Polys(GB);

  //trivial branches
  if (size(Gr))
  {
    ideal Tempdisequ = Product_sets(newDisEqu, Gr);
    if (Check_Consistence(newEqu, Tempdisequ))
    {
      CGSystems = list(list(newEqu, Tempdisequ, list(1)));
    }
  }

  if (!Check_Consistence(Gr, newDisEqu))
  {
    return(CGSystems);
  }

  if (size(MDBasis) == 0)
  {
    CGSystems = CGSystems + list(list(Gr, newDisEqu, list(0)));
    return(CGSystems);
  }
  

  //major branch
  ideal tempp = Product_sets(newDisEqu,ideal(H));
  if (Check_Consistence(Gr, tempp))
  {
    CGSystems = CGSystems + list(list(Gr, tempp, MDBasis));
  }
  
  //other branches
  ideal tempDisEqu = newDisEqu;
  for (i = 1; i <= size(LeadCoeffFactors); i++)
  {
    CGSystems = CGSystems + cgs_main(Gs,Gr + LeadCoeffFactors[i], tempDisEqu);
    tempDisEqu = Product_sets(tempDisEqu, ideal(LeadCoeffFactors[i]));
  }

  return(CGSystems);
}


static proc Separate_Polys(ideal GB)
{
  setring(RingVar);
  ideal newGB = imap(RingAll, GB);
  list MDBasis, GrList, MList, LCoefs;
  ideal Gs;
  poly P, mon;
  int length = size(newGB);
  int i, j;
  for (i = 1; i <= length; i++)
  {
    P = newGB[i];
    mon = leadmonom(P);
    if (mon == 1)
    {
      GrList = GrList + list(P);
    }
    else
    {
      Gs = Gs + newGB[i];
      for (j = 1; j <= size(MList); j++)
      {
        if (mon/MList[j] > 1|| mon/MList[j] ==1)
        {
	  mon = 0;
	  break;
        }
      }
      if (mon == 0)
      {
        i++;
        continue;
      }
      for (j = i + 1; j <= length; j++)
      {
	if (leadmonom(newGB[j]) != 1 && mon/leadmonom(newGB[j]) > 1)
	{
	  mon = 0;
	  break;
	}
      }
      if (mon == 0)
      {
        i ++;
        continue;
      }
      MDBasis = MDBasis + list(P);
      MList = MList + list(mon);
      LCoefs = LCoefs + list(leadcoef(P));
    }
  }

  int MDBasisLength = size(MDBasis);
  int GrListLength = size(GrList);
  int GsListLength = size(Gs);

  setring(RingAll);

  list MDBasis;
  ideal Gs, Gr, LeadCoeffFactors;
  poly g;

  if (GsListLength)
  {
    Gs = imap(RingVar, Gs);
  }
  if (GrListLength)
  {
    list GrList = imap(RingVar, GrList);
    for (i = 1; i <= GrListLength; i++)
    {
      Gr = Gr + GrList[i];
    }
  }

  if (MDBasisLength)
  {
    MDBasis  =  imap(RingVar, MDBasis);
    list LCoefs  =  imap(RingVar, LCoefs);
    g = 1;
    for (i = 1; i <= size(LCoefs); i++)
    {
      g = g * LCoefs[i];
    } 
    g = sqrfree(g,3);
    LeadCoeffFactors = factorize(g,1);
  }

  return(MDBasis, Gs, Gr, g, LeadCoeffFactors);
}



static proc Check_Consistence(ideal Equ, ideal DisEqu)
{
  //trivial checks
  if (size(DisEqu) == 0)
  {
    return(0);
  }
  if (size(Equ) == 0)
  {
    return(1);
  }
  if (Equ[1] == 1)
  {
    return(0);
  }
  if (DisEqu[1] == 1)
  {
    return(1);
  }

  //normal check
  int i, flag;
  for (i=1;i<=size(DisEqu);i++)
  {
    flag = rad_con(DisEqu[i], Equ);
    if ( flag == 0 )
    {
      return(1);
    }
  }

  return(0);
}



static proc Simplify_Equ(ideal Equ)
{
  if (size(Equ) == 0 || Equ[1] == 1)
  {
    return(Equ);
  }

  ideal newEqu;
  poly dis;

  for (int i = 1; i <= size(Equ); i++)
  {
    dis = sqrfree(Equ[i],3);
    newEqu = newEqu + dis;
  }
  return(newEqu);
}



static proc Simplify_DisEqu(ideal Equ, ideal DisEqu)
{
  if (size(Equ) == 0 || Equ[1] == 1)
  {
    return(DisEqu);
  }

  if (size(DisEqu) == 0 || DisEqu[1] == 1)
  {
    return(DisEqu);
  }

  ideal newDisEqu;
  poly dis,tempP;
  Equ = groebner(Equ);
  for (int i = 1; i <= size(DisEqu); i++)
  {
    dis = sqrfree(DisEqu[i],3);
    tempP = reduce(dis,Equ);
    if (leadmonom(tempP) == 1)
    {
      return(ideal(1));
    }
    else
    {
      if (tempP != 0)
      {
        newDisEqu = newDisEqu + tempP;
      }
    }
  }
  return(newDisEqu);
}



static proc Product_sets(ideal E, ideal N)
{
  if (size(E) == 0 || size(N) == 0)
  {
    return(ideal());
  }

  int i,j;
  ideal Temp;

  for(i=1;i<=size(N);i++)
  {
    for(j=1;j<=size(E);j++)
    {
      Temp = Temp + E[j]*N[i];
    }
  }

  return(Temp);
}